<template>
  <el-dropdown
    v-if="languages.length > 0"
    id="languageMenu"
    :trigger="
      !isMobile && themeColor.Text !== 'main_lightblue' ? 'hover' : 'click'
    "
    class="language-dropdown"
  >
    <div
      class="flex items-center justify-between cursor-pointer dropdown-list-menu"
    >
      <div class="mr-1" :class="isMobile ? 'icon-lang-mobile' : 'icon-lang'">
        <img
          :src="
            getAssetImage(
              `assets/materials/languageIcon/${defaultLanguage}.svg`
            )
          "
        />
      </div>
      <span class="--text3">{{ languageShortCodeForDisplay }}</span>
      <div class="w-4 h-4 flex justify-center items-center">
        <SvgIcon
          svg-name="dropdown-arrow"
          class="w-[10px] h-[6px] dropdown-arrow"
        />
      </div>
    </div>
    <template #dropdown>
      <div>
        <el-dropdown-menu class="bg-background1">
          <el-dropdown-item
            v-for="lang in languages"
            :key="lang"
            @click="switchLanguage(lang.ISO)"
          >
            <div class="--text2">{{ lang.LanguageLocalName }}</div>
          </el-dropdown-item>
        </el-dropdown-menu>
      </div>
    </template>
  </el-dropdown>
</template>
<script lang="ts">
import { computed, defineComponent } from "vue";
import { useLanguageComponent } from "@/composables/useTheme";
import commonHelper from "@/utils/commonHelper";
import themePropertyHelper from "@/utils/themePropertyHelper";
import { IThemePropertiesFromApi } from "@/models/companyThemePropertiesRespone";
import { store } from "@/store";

export default defineComponent({
  name: "LanguageComponent",
  setup() {
    const isMobile = !useIsDesktop();
    const themeProperties = computed(
      () => store.state.companyThemePropertiesFromApi.ThemeProperties
    );
    const themeColor = computed(
      (): IThemePropertiesFromApi =>
        themePropertyHelper.getSingleThemeProperty(
          themeProperties.value,
          "theme_color"
        )
    );
    const { getAssetImage } = commonHelper;
    const { ...props } = useLanguageComponent();
    return {
      ...props,
      getAssetImage,
      isMobile,
      themeColor,
    };
  },
});
</script>
<style scoped lang="scss">
.icon-lang {
  img {
    width: 100%;
    height: 100%;
    border-radius: 50%;
    object-fit: cover;
  }
  height: 24px;
  width: 24px;
  border-radius: 50%;
  background: #fff;
}
.icon-lang-mobile {
  img {
    width: 100%;
    height: 100%;
    border-radius: 2px;
    object-fit: cover;
  }
  height: 16px;
  width: 22px;
  border-radius: 2px;
  background: #fff;
}
</style>
<style scoped>
:deep(.el-dropdown-menu__item) {
  --el-dropdown-menuItem-hover-fill: var(--primary);
  --el-dropdown-menuItem-hover-color: #fff;
}
</style>
<style>
.el-dropdown__popper.el-popper[role="tooltip"] {
  background: var(--background1);
  border: 1px solid var(--background1);
  color: #fff;
  min-width: 151.22px;
}
.el-dropdown__popper.el-popper[role="tooltip"] .el-popper__arrow::before {
  border: 1px solid var(--background1);
}

body .dropdown-list-menu::after {
    border-color: white transparent transparent;
    border-style: solid;
    border-width: 0.375rem 0.25rem 0;
    content: "";
    display: none;
    flex-shrink: 0;
    height: 0;
    width: 0;
}
.dropdown-arrow {
  fill: var(--text3);
}
</style>
